package j2d.gui.menu;

import bookExamples.ch26Graphics.draw2d.DrawMain;
import bookExamples.ch26Graphics.draw2d.shapes.ImageShape;
import gui.ClosableJFrame;
import gui.run.RunMenu;
import gui.run.RunMenuItem;
import j2d.border.BorderPanel;
import j2d.color.rgbImageFilters.LogXformPanel;
import j2d.gui.Main;
import j2d.rotator.Turn180Processor;
import j2d.rotator.Transpose;
import j2d.transforms.*;

import java.awt.*;
import java.util.Observable;
import java.util.Observer;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Nov 2, 2005
 * Time: 6:13:21 PM
 */
public class ShapeMenu extends RunMenu {
    private Main main;

    public ShapeMenu(Main main) {
        super("Shape");
        this.main = main;
        init();

    }

    private void init() {

        add(new RunMenuItem("start draw program") {
            public void run() {
                startDrawMenu();
            }
        });
        addLogPolar();
        add(new RunMenuItem("BorderPanel") {
            public void run() {
                main.addPanel(new BorderPanel(main), getText());
            }
        });
        addTurn();

    }

    private void startDrawMenu() {
        DrawMain dm = new DrawMain();
        ClosableJFrame cf = new ClosableJFrame("DocJavaDraw");
        cf.setJMenuBar(dm.getRunMenuBar());
        Image img = main.getBaseImage();
        int w = img.getWidth(null);
        int h = img.getHeight(null);
        dm.setLastSelectedShape(new ImageShape(0, 0, w, h, img));
        Container c = cf.getContentPane();
        c.setLayout(new BorderLayout());
        c.add(dm, BorderLayout.CENTER);
        cf.setSize(300, 300);
        cf.setVisible(true);
        dm.addCroppedImageObserver(new Observer() {
            public void update(Observable o, Object arg) {
                createNewImageFrame((Image) arg);
            }

        });
    }

    private void createNewImageFrame(Image image) {
        main.addImage(image);
    }

    public void addLogPolar() {
        add(new RunMenuItem("Log Polar transform") {
            public void run() {
                main.addPanel(new LogXformPanel(main), getText());
            }
        });
    }

    public void addTurn() {
        add(new RunMenuItem("Transpose") {
            public void run() {
                main.process(new Transpose());
            }
        });
        add(new RunMenuItem("Turn180") {
            public void run() {
                main.process(new Turn180Processor());
            }
        });
        add(new RunMenuItem("Mirror") {
            public void run() {
                main.process(new j2d.rotator.TurnMirrorProcessor());
            }
        });
           add(new RunMenuItem("UpsideDownMirrorProcessor") {
            public void run() {
                main.process(new j2d.rotator.UpsideDownMirrorProcessor());
            }
        });

    }
}
